﻿#!/bin/sh

WORK_DIR=$(cd $(dirname $0); pwd)
# WORK_DIR=/opt/software/sof
SOFTWARE_DIR=/opt/software
QTAPP=${WORK_DIR}/miniLCD
RUNPARA=" -qws"

# USB_DIR=$1

# motor init
if [ -e ${WORK_DIR}/motor_init ]; then
    ${WORK_DIR}/motor_init
fi

# stop
/etc/init.d/S50telnet  stop

LOG=/data/var/run.log

echo "" > $LOG
# echo "WORK_DIR: ${WORK_DIR}"
# echo "SOFTWARE_DIR:${SOFTWARE_DIR}"
# echo "USB_DIR: ${USB_DIR}"

# find max dir
cd  ${SOFTWARE_DIR}
NEW_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 1`
OLD_APP_DIR=`ls -vd [0-9].[0-9]*.[0-9]* | tail -n 2 | head  -n 1`
ISUPDATE=0
if [ -d ${SOFTWARE_DIR}/${NEW_APP_DIR} ] && \
    [ -d ${SOFTWARE_DIR}/${OLD_APP_DIR} ] && \
    [ ${SOFTWARE_DIR}/${OLD_APP_DIR} !=  ${SOFTWARE_DIR}/${NEW_APP_DIR} ]; then
    # NEW_APP_DIR=${SOFTWARE_DIR}/${NEW_APP_DIR}
    # OLD_APP_DIR=${SOFTWARE_DIR}/${OLD_APP_DIR}
    echo "NEW_APP_DIR:${NEW_APP_DIR}"
    echo "OLD_APP_DIR:${OLD_APP_DIR}"
    ISUPDATE=1
else
    echo "miss OLD_APP_DIR"  >> $LOG
    # NEW_APP_DIR=" "
    # NEW_APP_DIR=${NEW_APP_DIR}
    OLD_APP_DIR="NULL"
fi

#plug
if [ -e ${SOFTWARE_DIR}/sof/plug-in/plug-in.sh ]; then
    ${SOFTWARE_DIR}/sof/plug-in/plug-in.sh
    rm  -rf ${SOFTWARE_DIR}/sof/plug-in
fi


# install fonts
FONTS_PACKAGE=/opt/library/lib/fonts.zip
if [ -e ${FONTS_PACKAGE} ]; then
    echo "install fonts"
    rm -rf /tmp/*.ttf
    unzip ${FONTS_PACKAGE} -d /tmp
fi

# load env
DIR_TMP=${WORK_DIR}
. ${WORK_DIR}/load_env.sh ${USB_DIR}
WORK_DIR=${DIR_TMP}

#network
# eth0
MAC_FILE=/etc/MAC
if [ -e ${MAC_FILE} ]; then
    MAC_ADDR=`cat ${MAC_FILE}`
    ifconfig eth0 down
	ifconfig eth0 hw ether "${MAC_ADDR}"
fi
echo "MAC:${MAC_ADDR}" >> $LOG
ifconfig eth0 up


wifi8188ko=/opt/kernel/ker/8188fu.ko
if [ -e ${wifi8188ko} ]; then
    echo 142 > /sys/class/gpio/export
    echo 'out' > /sys/class/gpio/gpio142/direction
    echo 0 > /sys/class/gpio/gpio142/value
    insmod ${wifi8188ko}
    ifconfig wlan0 up
fi

#debug
 echo "1" > /proc/sys/kernel/core_uses_pid
 echo "/data/var/core-%e-%p-%t" > /proc/sys/kernel/core_pattern

if [ -e ${USB_DIR} ]; then
    umount ${USB_DIR}
fi

# running app
if [ -f ${QTAPP} ] ;then
     echo "*****running app******"
     killall  ipcsystem
     ${WORK_DIR}/ipcsystem &
     chmod  111  ${QTAPP}
     ${QTAPP}${RUNPARA}&
     sleep 5;
fi


# count=`ps -ef |grep ${QTAPP} |grep -v "grep" |wc -l`
count=`ps |grep ${QTAPP} |grep -v "grep" |wc -l`
if [ 0 == $count ] && [ 1 == $ISUPDATE ];then
    echo "*******${QTAPP}  not start *********"
    cd ${SOFTWARE_DIR}
    rm -rf sof
    rm -rf ${NEW_APP_DIR};sync
    ln -sf ${OLD_APP_DIR} sof
    sync
    if [ -f ${QTAPP} ] ;then
        chmod  111  ${QTAPP}
        ${QTAPP} -qws RELEASE upgrade_fail &
    fi
else
    echo "******${QTAPP} start success*******"
    if [ -d ${SOFTWARE_DIR}/${OLD_APP_DIR} ]; then
        echo "rm old app"
        rm -rf ${SOFTWARE_DIR}/${OLD_APP_DIR}
    fi
fi

